From a551f0c52347e35e470e147669cdc8b79768a8f4 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:41:17 +0000
Subject: [PATCH 876/1001] Cache the list of packages owned by the user


---

diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 8939130..1c37299 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -5,7 +5,7 @@ import pkgwat.api
 
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
-from hubs.widgets.caching import CachedFunction
+from hubs.widgets.caching import CachedFunction, cache
 
 
 PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
@@ -97,10 +97,16 @@ class GetIssues(CachedFunction):
         except KeyError:
             return False
         username = self.instance.config["username"]
-        url = "/".join([PKGDB_URL, username])
-        response = requests.get(url)
-        data = response.json()
 
-        owned = data['point of contact'] + data['co-maintained']
-        owned = [p['name'] for p in owned]
+        # Cache for a while the list of packages owned by the user, the HTTP
+        # request is waaaay too long to be run on each incoming bug message.
+        def get_owned():
+            url = "/".join([PKGDB_URL, username])
+            response = requests.get(url)
+            data = response.json()
+            owned = data['point of contact'] + data['co-maintained']
+            return [p['name'] for p in owned]
+        owned_cache_key = ":".join(["owned_packages", username])
+        # Cache for 5 minutes, it seems reasonable.
+        owned = cache.get_or_create(owned_cache_key, get_owned, 5 * 60)
         return (component in owned)

